;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This file is included directly in the Snowdrop OS kernel.
; It contains keyboard scan code definitions.
;
; This file is part of the Snowdrop OS homebrew operating system
;			written by Sebastian Mihai, http://sebastianmihai.com
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; function keys row
SCAN_CODE_ESCAPE 		equ 01h
SCAN_CODE_F1			equ 3Bh
SCAN_CODE_F2			equ 3Ch
SCAN_CODE_F3			equ 3Dh
SCAN_CODE_F4			equ 3Eh
SCAN_CODE_F5			equ 3Fh
SCAN_CODE_F6			equ 40h
SCAN_CODE_F7			equ 41h
SCAN_CODE_F8			equ 42h
SCAN_CODE_F9			equ 43h
SCAN_CODE_F10			equ 44h
SCAN_CODE_PRINT_SCREEN	equ 37h
SCAN_CODE_SCROLL_LOCK	equ 46h

; group of six above arrow keys
SCAN_CODE_INSERT		equ 52h
SCAN_CODE_DELETE		equ 53h
SCAN_CODE_HOME			equ 47h
SCAN_CODE_END			equ 4Fh
SCAN_CODE_PAGE_UP		equ 49h
SCAN_CODE_PAGE_DOWN		equ 51h

; arrow keys
SCAN_CODE_DOWN_ARROW 	equ 50h
SCAN_CODE_RIGHT_ARROW 	equ 4Dh
SCAN_CODE_LEFT_ARROW 	equ 4Bh
SCAN_CODE_UP_ARROW 		equ 48h

; first row
SCAN_CODE_BACKQUOTE		equ 29h
SCAN_CODE_NUMBER_1		equ 02h
SCAN_CODE_NUMBER_2		equ 03h
SCAN_CODE_NUMBER_3		equ 04h
SCAN_CODE_NUMBER_4		equ 05h
SCAN_CODE_NUMBER_5		equ 06h
SCAN_CODE_NUMBER_6		equ 07h
SCAN_CODE_NUMBER_7		equ 08h
SCAN_CODE_NUMBER_8		equ 09h
SCAN_CODE_NUMBER_9		equ 0Ah
SCAN_CODE_NUMBER_0		equ 0Bh
SCAN_CODE_MINUS			equ 0Ch
SCAN_CODE_EQUALS		equ 0Dh
SCAN_CODE_BACKSPACE		equ 0Eh

; second row
SCAN_CODE_TAB			equ 0Fh
SCAN_CODE_Q				equ 10h
SCAN_CODE_W				equ 11h
SCAN_CODE_E				equ 12h
SCAN_CODE_R				equ 13h
SCAN_CODE_T				equ 14h
SCAN_CODE_Y				equ 15h
SCAN_CODE_U				equ 16h
SCAN_CODE_I				equ 17h
SCAN_CODE_O				equ 18h
SCAN_CODE_P				equ 19h
SCAN_CODE_SQR_BRACKET_L	equ 1Ah
SCAN_CODE_SQR_BRACKET_R	equ 1Bh
SCAN_CODE_SQR_BACKSLASH	equ 2Bh

; third row
SCAN_CODE_CAPS_LOCK		equ 3Ah
SCAN_CODE_A				equ 1Eh
SCAN_CODE_S				equ 1Fh
SCAN_CODE_D				equ 20h
SCAN_CODE_F				equ 21h
SCAN_CODE_G				equ 22h
SCAN_CODE_H				equ 23h
SCAN_CODE_J				equ 24h
SCAN_CODE_K				equ 25h
SCAN_CODE_L				equ 26h
SCAN_CODE_SEMICOLON		equ 27h
SCAN_CODE_QUOTE			equ 28h
SCAN_CODE_ENTER 		equ 1Ch

; fourth row
SCAN_CODE_LEFT_SHIFT	equ 2Ah
SCAN_CODE_Z				equ 2Ch
SCAN_CODE_X				equ 2Dh
SCAN_CODE_C				equ 2Eh
SCAN_CODE_V				equ 2Fh
SCAN_CODE_B				equ 30h
SCAN_CODE_N				equ 31h
SCAN_CODE_M				equ 32h
SCAN_CODE_COMMA			equ 33h
SCAN_CODE_PERIOD		equ 34h
SCAN_CODE_SLASH			equ 35h
SCAN_CODE_RIGHT_SHIFT	equ 36h

; fifth row
SCAN_CODE_LEFT_CONTROL	equ 1Dh
SCAN_CODE_LEFT_ALT		equ 38h
SCAN_CODE_SPACE_BAR		equ 39h
SCAN_CODE_RIGHT_ALT		equ 38h
SCAN_CODE_RIGHT_CONTROL	equ 1Dh

; keypad
SCAN_CODE_NUMLOCK		equ 45h
SCAN_CODE_KEYPAD_SLASH	equ 35h
SCAN_CODE_KEYPAD_ASTRISK	equ 37h
SCAN_CODE_KEYPAD_MINUS	equ 4Ah
SCAN_CODE_KEYPAD_7		equ 47h
SCAN_CODE_KEYPAD_8		equ 48h
SCAN_CODE_KEYPAD_9		equ 49h
SCAN_CODE_KEYPAD_4		equ 4Bh
SCAN_CODE_KEYPAD_5		equ 4Ch
SCAN_CODE_KEYPAD_6		equ 4Dh
SCAN_CODE_KEYPAD_PLUS	equ 4Eh
SCAN_CODE_KEYPAD_1		equ 4Fh
SCAN_CODE_KEYPAD_2		equ 50h
SCAN_CODE_KEYPAD_3		equ 51h
SCAN_CODE_KEYPAD_0		equ 52h
SCAN_CODE_KEYPAD_PERIOD	equ 53h
SCAN_CODE_KEYPAD_ENTER	equ 1Ch


; The following are combination scan codes generated by the BIOS driver
SCAN_CODE_AND_ASCII_CTRL_C	equ 2E03h
SCAN_CODE_AND_ASCII_CTRL_D	equ 2004h
SCAN_CODE_AND_ASCII_CTRL_I	equ 1709h
SCAN_CODE_AND_ASCII_CTRL_L	equ 260Ch
SCAN_CODE_AND_ASCII_CTRL_Q	equ 1011h
SCAN_CODE_AND_ASCII_CTRL_V	equ 2F16h
